import numpy as np
import random
import os
import math
import pandas
from pyitlib import discrete_random_variable as drv
from itertools import groupby
from funcy import group_by
import ent

pandas.options.mode.chained_assignment = None 

if not os.path.exists('results_overall'):
    os.makedirs('results_overall')


codr = ["v","d","l","n","r","m","ɣ","z","ʁ","ŋ"]
natr = ["y","b"]


if ent.inputfile == "allverbs.csv":
    v1r = ["æ","i","ə","e","u","ɑ","o"]
    v2r = ["i","ə","o","u","æ","ɑ","e"]
    outputfile1 = "boot_allverbs/boot_a_allverbs.csv"
    outputfile2 = "boot_allverbs/boot_b_allverbs.txt"
    pfile = "boot_allverbs/boot_allverbs_pvalues.txt" 
    if not os.path.exists('results_overall/boot_allverbs'):
        os.makedirs('results_overall/boot_allverbs')


if ent.inputfile == "ablauting.csv":
    v1r = ["æ","ə","o"]
    v2r = ["i","ə","o","u"]
    outputfile1 = 'boot_ablauting/boot_a_ablauting.csv'
    outputfile2 = 'boot_ablauting/boot_b_ablauting.txt'
    pfile = "boot_ablauting/boot_ablauting_pvalues.txt" 
    if not os.path.exists('results_overall/boot_ablauting'):
        os.makedirs('results_overall/boot_ablauting')


#Output file
path=os.path.join('results_overall/',outputfile1)
with open(path,'a+') as f:
    print("Hv1v2,Hv1codv2,Hv1nv2,Hv1codnv2,Hv2v1,Hv2codv1,Hv2nv1,Hv2codnv1",file=f)  



j = 0
pallent = 0
pv1v2 = 0
pv1codv2 = 0
pv1nv2 = 0
pallent2 = 0
pv2v1 = 0
pv2codv1 = 0
pv2nv1 =0


iterations = input("How many times do you want to run the bootstrap? ")
times = int(iterations)
for i in range(times):

    #Predicting Stem 2

#### overall ############################

    length1 = ent.prepatternfn.shape[0]
    with open('results_overall/prebootall.csv','a+') as fic:
        print("s1vowel",",","s2vowel",",","nativeness",",","coda",sep='',file=fic)
        rowlists = []
        i = 0
        while len(rowlists) < length1:
            row = [random.choice(v1r), random.choice(v2r),random.choice(natr),random.choice(codr)]
            i = i + 1
            if row not in rowlists:
                rowlists.append(row)
                print(",".join(row),file=fic)

    preran = pandas.read_csv('results_overall/prebootall.csv')  

    with open('results_overall/bootall.csv','a+') as fic:
        preran.to_csv('results_overall/bootall.csv',index=False)
        rowlists2 = []
        k = 0
        while len(rowlists2) < ent.prepattern.shape[0] - length1:
            row = preran.sample(1)
            k = k + 1
            rowlists2.append(row.iloc[0])
            print(",".join(row.iloc[0]),file=fic)


    ran = pandas.read_csv('results_overall/bootall.csv')

    rv1v2 = ran[['s1vowel','s2vowel']]

    #Combine v1 v2

    rv1v2['rv1v2'] = rv1v2.s1vowel + rv1v2.s2vowel

    #Extract the column v1v2

    rv1v2 = rv1v2[['rv1v2']]

    #to list the patterns

    rvlist = rv1v2.rv1v2.tolist()

    #Remove duplicates
    rvlist2 = list(dict.fromkeys(rvlist))

    #Grouping the patterns and keep the values
    rvlistgrouped = group_by(0,rvlist2).values()

    #Add corresponding patterns to a list
    rvpatterns = []
    for rv in rvlist:
        for p in rvlistgrouped:
            if rv in p:
                p=''.join(p)
                rvpatterns.append(p)

    #Add the patterns to csv
    rv1v2['rv1v1v2']=rvpatterns


    #Remove duplicates and get the csv for computing
    rv1v2fn = rv1v2.drop_duplicates(subset=None)




    #Find patterns for n ~  v2

    rnv2 = ran[['nativeness','s2vowel']]

    #Combine n v2
    rnv2['rnv2'] = rnv2.nativeness + rnv2.s2vowel

    #Extract the colunn nv2
    rnv2 = rnv2[['rnv2']]

    #to list the patterns
    rnlist = rnv2.rnv2.tolist()

    #Remove duplicates
    rnlist2 = list(dict.fromkeys(rnlist))

    #Grouping the patterns and keep the values
    rnlistgrouped = group_by(0,rnlist2).values()

    #Add corresponding patterns to a list
    rnpatterns = []
    for rn in rnlist:
        for p in rnlistgrouped:
            if rn in p:
                p=''.join(p)
                rnpatterns.append(p)

    #Add the patterns to csv
    rnv2['rnnv2'] = rnpatterns

    #Remove duplicates and get the csv for computing
    rnv2fn = rnv2.drop_duplicates(subset=None)





    #Find patterns for c ~  v2

    rcv2 = ran[['coda','s2vowel']]

    #Combine c v2
    rcv2['rcv2'] = rcv2.coda + rcv2.s2vowel

    #Extract the colunn cv2
    rcv2 = rcv2[['rcv2']]

    #to list the patterns
    rclist = rcv2.rcv2.tolist()

    #Remove duplicates
    rclist2 = list(dict.fromkeys(rclist))

    #Grouping the patterns and keep the values
    rclistgrouped = group_by(0,rclist2).values()

    #Add corresponding patterns to a list
    rcpatterns = []
    for rc in rclist:
        for p in rclistgrouped:
            if rc in p:
                p=''.join(p)
                rcpatterns.append(p)

    #Add the patterns to csv
    rcv2['rccv2'] = rcpatterns

    #Remove duplicates and get the csv for computing
    rcv2fn = rcv2.drop_duplicates(subset=None)

    #Get v1 ~ nativeness
    rv1n =  ran[['s1vowel','nativeness']]
    rv1n['rv1n'] = rv1n.s1vowel + rv1n.nativeness
    rv1n = rv1n[['rv1n']]

    #Get v1 ~ coda
    rv1c =  ran[['s1vowel','coda']]
    rv1c['rv1c'] = rv1c.s1vowel + rv1c.coda
    rv1c = rv1c[['rv1c']]

    #Get nativeness ~ coda
    rnc =  ran[['nativeness','coda']]
    rnc['rnc'] = rnc.nativeness + rnc.coda
    rnc = rnc[['rnc']]

    #Combine all patterns
    rallpatterns = pandas.concat([rv1v2, rnv2, rcv2,rv1n,rv1c,rnc], axis=1, join='inner')

    #Remove duplicates
    rallpatternsfn = rallpatterns.drop_duplicates(subset=None)

    #compute H(v1, coda, nativeness => v2)
    rallpatternsb = rallpatterns[['rv1v1v2','rnnv2','rccv2','rv1c','rv1n','rnc']]
    rallent1 = drv.entropy_joint(rallpatterns.T)
    rallent2 = drv.entropy_joint(rallpatternsb.T)
    rallent = rallent1 - rallent2 
    os.remove('results_overall/bootall.csv')
    os.remove('results_overall/prebootall.csv')
    if rallent < ent.allent:
        pallent = pallent + 1
        print ("H(v1, coda, nativeness => v2): bootstrap < actual, the values are: ",rallent,",",ent.allent,",","consider keeping the null hypothesis?")



# V1 => V2

    length2 = ent.v1v2fn.shape[0]
    with open('results_overall/prebootv1v2.csv','a+') as fic:
        print("s1vowel",",","s2vowel",sep='',file=fic)
        rowlists = []
        i = 0
        while len(rowlists) < length2:
            row = [random.choice(v1r), random.choice(v2r)]
            i = i + 1
            if row not in rowlists:
                rowlists.append(row)
                print(",".join(row),file=fic)
 
    preran = pandas.read_csv('results_overall/prebootv1v2.csv')  
    
    with open('results_overall/bootv1v2.csv','a+') as fic:
        preran.to_csv('results_overall/bootv1v2.csv',index=False)
        rowlists2 = []
        k = 0
        while len(rowlists2) < ent.v1v2.shape[0] - length2:
            row = preran.sample(1)
            k = k + 1
            rowlists2.append(row.iloc[0])
            print(",".join(row.iloc[0]),file=fic)


    btv1v2 = pandas.read_csv('results_overall/bootv1v2.csv')

    #Combine v1 v2

    btv1v2['btv1v2'] = btv1v2.s1vowel + btv1v2.s2vowel

    #Extract the column v1v2

    btv1v2 = btv1v2[['btv1v2']]

    #to list the patterns

    btvlist = btv1v2.btv1v2.tolist()

    #Remove duplicates
    btvlist2 = list(dict.fromkeys(btvlist))

    #Grouping the patterns and keep the values
    btvlistgrouped = group_by(0,btvlist2).values()

    #Add corresponding patterns to a list
    btvpatterns = []
    for rv in btvlist:
        for p in btvlistgrouped:
            if rv in p:
                p=''.join(p)
                btvpatterns.append(p)

    #Add the patterns to csv
    btv1v2['btv1v1v2']=btvpatterns


    #Remove duplicates and get the csv for computing
    btv1v2fn = btv1v2.drop_duplicates(subset=None)

    #compute v1 ~ v2 entropy
    btprev1v2 = drv.entropy_conditional(btv1v2fn.T)

    rv1v2entropy = btprev1v2[0,1]
    os.remove('results_overall/bootv1v2.csv')
    os.remove('results_overall/prebootv1v2.csv')
    if rv1v2entropy < ent.v1v2entropy:
        pv1v2 = pv1v2 + 1
        print ("H(v1 => v2): bootstrap < actual, the values are: ", rv1v2entropy,",",ent.v1v2entropy,",","consider keeping the null hypothesis?")



# V1, coda => V2



    length3 = ent.v1codv2fn.shape[0]
    with open('results_overall/prebootv1codv2.csv','a+') as fic:
        print("s1vowel",",","s2vowel",",","coda",sep='',file=fic)
        rowlists = []
        i = 0
        while len(rowlists) < length3:
            row = [random.choice(v1r), random.choice(v2r),random.choice(codr)]
            i = i + 1
            if row not in rowlists:
                rowlists.append(row)
                print(",".join(row),file=fic)

    preran = pandas.read_csv('results_overall/prebootv1codv2.csv')  
    
    with open('results_overall/bootv1codv2.csv','a+') as fic:
        preran.to_csv('results_overall/bootv1codv2.csv',index=False)
        rowlists2 = []
        k = 0
        while len(rowlists2) < ent.v1codv2.shape[0] - length3:
            row = preran.sample(1)
            k = k + 1
            rowlists2.append(row.iloc[0])
            print(",".join(row.iloc[0]),file=fic)

    
    ran2 =  pandas.read_csv('results_overall/bootv1codv2.csv')

    ctv1v2 = ran2[['s1vowel','s2vowel']]

    ctv1v2['ctv1v2'] = ctv1v2.s1vowel + ctv1v2.s2vowel

    #Extract the column v1v2

    ctv1v2 = ctv1v2[['ctv1v2']]

    #to list the patterns

    ctvlist = ctv1v2.ctv1v2.tolist()

    #Remove duplicates
    ctvlist2 = list(dict.fromkeys(ctvlist))

    #Grouping the patterns and keep the values
    ctvlistgrouped = group_by(0,ctvlist2).values()

    #Add corresponding patterns to a list
    ctvpatterns = []
    for rv in ctvlist:
        for p in ctvlistgrouped:
            if rv in p:
                p=''.join(p)
                ctvpatterns.append(p)

    #Add the patterns to csv
    ctv1v2['ctv1v1v2']=ctvpatterns


    #Find patterns for c ~  v2

    ctcv2 = ran2[['coda','s2vowel']]

    #Combine c v2
    ctcv2['ctcv2'] = ctcv2.coda + ctcv2.s2vowel

    #Extract the colunn cv2
    ctcv2 = ctcv2[['ctcv2']]

    #to list the patterns
    ctclist = ctcv2.ctcv2.tolist()

    #Remove duplicates
    ctclist2 = list(dict.fromkeys(ctclist))

    #Grouping the patterns and keep the values
    ctclistgrouped = group_by(0,ctclist2).values()

    #Add corresponding patterns to a list
    ctcpatterns = []
    for rc in ctclist:
        for p in ctclistgrouped:
            if rc in p:
                p=''.join(p)
                ctcpatterns.append(p)

    #Add the patterns to csv
    ctcv2['ctccv2'] = ctcpatterns


    #Get v1 ~ coda
    ctv1c =  ran2[['s1vowel','coda']]
    ctv1c['ctv1c'] = ctv1c.s1vowel + ctv1c.coda
    ctv1c = ctv1c[['ctv1c']]


    #Combine all patterns
    ctall1c2 = pandas.concat([ctv1v2,ctcv2,ctv1c], axis=1, join='inner')

    #Remove duplicates
    ctall1c2fn = ctall1c2.drop_duplicates(subset=None)

    ctv1codv2b = ctall1c2[['ctv1v1v2','ctccv2','ctv1c']]
    ctv1codv2ent1 = drv.entropy_joint(ctall1c2.T)
    ctv1codv2ent2 = drv.entropy_joint(ctv1codv2b.T)
    rhv1codv2 = ctv1codv2ent1 - ctv1codv2ent2
    os.remove('results_overall/bootv1codv2.csv')
    os.remove('results_overall/prebootv1codv2.csv')
    if rhv1codv2 < ent.hv1codv2:
        pv1codv2 = pv1codv2 + 1
        print ("H(v1, coda => v2): bootstrap < actual, the values are: ",rhv1codv2,",", ent.hv1codv2,",","consider keeping the null hypothesis?")



# V1, nativeness => V2



    length4 = ent.v1nv2fn.shape[0]
    with open('results_overall/prebootv1nv2.csv','a+') as fic:
        print("s1vowel",",","s2vowel",",","nativeness",sep='',file=fic)
        rowlists = []
        i = 0
        while len(rowlists) < length4:
            row = [random.choice(v1r), random.choice(v2r),random.choice(natr)]
            i = i + 1
            if row not in rowlists:
                rowlists.append(row)
                print(",".join(row),file=fic)

    preran = pandas.read_csv('results_overall/prebootv1nv2.csv')  
    
    with open('results_overall/bootv1nv2.csv','a+') as fic:
        preran.to_csv('results_overall/bootv1nv2.csv',index=False)
        rowlists2 = []
        k = 0
        while len(rowlists2) < ent.v1nv2.shape[0] - length4:
            row = preran.sample(1)
            k = k + 1
            rowlists2.append(row.iloc[0])
            print(",".join(row.iloc[0]),file=fic)

    
    ran3 =  pandas.read_csv('results_overall/bootv1nv2.csv')

    dtv1v2 = ran3[['s1vowel','s2vowel']]

    dtv1v2['dtv1v2'] = dtv1v2.s1vowel + dtv1v2.s2vowel

    #Extract the column v1v2

    dtv1v2 = dtv1v2[['dtv1v2']]

    #to list the patterns

    dtvlist = dtv1v2.dtv1v2.tolist()

    #Remove duplicates
    dtvlist2 = list(dict.fromkeys(dtvlist))

    #Grouping the patterns and keep the values
    dtvlistgrouped = group_by(0,dtvlist2).values()

    #Add corresponding patterns to a list
    dtvpatterns = []
    for rv in dtvlist:
        for p in dtvlistgrouped:
            if rv in p:
                p=''.join(p)
                dtvpatterns.append(p)

    #Add the patterns to csv
    dtv1v2['dtv1v1v2']=dtvpatterns



    #Find patterns for n ~  v2

    dtnv2 = ran3[['nativeness','s2vowel']]

    #Combine n v2
    dtnv2['dtnv2'] = dtnv2.nativeness + dtnv2.s2vowel

    #Extract the colunn nv2
    dtnv2 = dtnv2[['dtnv2']]

    #to list the patterns
    dtnlist = dtnv2.dtnv2.tolist()

    #Remove duplicates
    dtnlist2 = list(dict.fromkeys(dtnlist))

    #Grouping the patterns and keep the values
    dtnlistgrouped = group_by(0,dtnlist2).values()

    #Add corresponding patterns to a list
    dtnpatterns = []
    for rn in dtnlist:
        for p in dtnlistgrouped:
            if rn in p:
                p=''.join(p)
                dtnpatterns.append(p)

    #Add the patterns to csv
    dtnv2['dtnnv2'] = dtnpatterns


    #Get v1 ~ nativeness
    dtv1n =  ran3[['s1vowel','nativeness']]
    dtv1n['dtv1n'] = dtv1n.s1vowel + dtv1n.nativeness
    dtv1n = dtv1n[['dtv1n']]

    #Combine all patterns
    dtall1n2 = pandas.concat([dtv1v2,dtnv2,dtv1n], axis=1, join='inner')

    #Remove duplicates
    dtall1n2fn = dtall1n2.drop_duplicates(subset=None)

    #compute H(v1, nativeness => v2)
    dtv1nv2b = dtall1n2[['dtv1v1v2','dtnnv2','dtv1n']]
    dtv1nv2ent1 = drv.entropy_joint(dtall1n2.T)
    dtv1nv2ent2 = drv.entropy_joint(dtv1nv2b.T)
    rhv1nv2 = dtv1nv2ent1 - dtv1nv2ent2 
    os.remove('results_overall/bootv1nv2.csv')
    os.remove('results_overall/prebootv1nv2.csv')
    if rhv1nv2 < ent.hv1nv2:
        pv1nv2 = pv1nv2 + 1
        print ("H(v1, nativeness => v2): bootstrap < actual, the values are: ",rhv1nv2,",",ent.hv1nv2,",","consider keeping the null hypothesis?")








###################################################
###################################################
###################################################


   #Predicting Stem 1

   #Overall

    length5 = ent.prepattern2.shape[0]
    with open('results_overall/prebootall2.csv','a+') as fic:
        print("s1vowel",",","s2vowel",",","nativeness",",","coda",sep='',file=fic)
        rowlists = []
        i = 0
        while len(rowlists) < length5:
            row = [random.choice(v1r), random.choice(v2r),random.choice(natr),random.choice(codr)]
            i = i + 1
            if row not in rowlists:
                rowlists.append(row)
                print(",".join(row),file=fic)

    preran = pandas.read_csv('results_overall/prebootall2.csv')  
    
    with open('results_overall/bootall2.csv','a+') as fic:
        preran.to_csv('results_overall/bootall2.csv',index=False)
        rowlists2 = []
        k = 0
        while len(rowlists2) < ent.prepattern2.shape[0] - length5:
            row = preran.sample(1)
            k = k + 1
            rowlists2.append(row.iloc[0])
            print(",".join(row.iloc[0]),file=fic)


    rprepattern2 = pandas.read_csv('results_overall/bootall2.csv')

    rv2v1 = rprepattern2[['s2vowel','s1vowel']]

    #Combine v1 v2

    rv2v1['rv2v1'] = rv2v1.s2vowel + rv2v1.s1vowel

    rv2v1 = rv2v1[['rv2v1']]

    rvolist = rv2v1.rv2v1.tolist()

    #Remove duplicates
    rvolist2 = list(dict.fromkeys(rvolist))

    #Grouping the patterns and keep the values
    rvolistgrouped = group_by(0,rvolist2).values()

    #Add corresponding patterns to a list
    rvopatterns = []
    for rvo in rvolist:
        for p in rvolistgrouped:
            if rvo in p:
                p=''.join(p)
                rvopatterns.append(p)

    #Add the patterns to csv
    rv2v1['rv2v2v1']=rvopatterns

    #Remove duplicates and get the csv for computing
    rv2v1fn = rv2v1.drop_duplicates(subset=None)




    #Find patterns for n ~  v1

    rnv1 = rprepattern2[['nativeness','s1vowel']]

    #Combine n v1
    rnv1['rnv1'] = rnv1.nativeness + rnv1.s1vowel

    #Extract the colunn nv1
    rnv1 = rnv1[['rnv1']]

    #to list the patterns
    rnalist = rnv1.rnv1.tolist()

    #Remove duplicates
    rnalist2 = list(dict.fromkeys(rnalist))

    #Grouping the patterns and keep the values
    rnalistgrouped = group_by(0,rnalist2).values()

    #Add corresponding patterns to a list
    rnapatterns = []
    for rna in rnalist:
        for p in rnalistgrouped:
            if rna in p:
                p=''.join(p)
                rnapatterns.append(p)

    #Add the patterns to csv
    rnv1['rnnv1'] = rnapatterns

    #Remove duplicates and get the csv for computing
    rnv1fn = rnv1.drop_duplicates(subset=None)



    #Find patterns for c ~  v1

    rcv1 = rprepattern2[['coda','s1vowel']]

    #Combine c v2
    rcv1['rcv1'] = rcv1.coda + rcv1.s1vowel

    #Extract the colunn cv2
    rcv1 = rcv1[['rcv1']]

    #to list the patterns
    rcolist = rcv1.rcv1.tolist()

    #Remove duplicates
    rcolist2 = list(dict.fromkeys(rcolist))

    #Grouping the patterns and keep the values
    rcolistgrouped = group_by(0,rcolist2).values()

    #Add corresponding patterns to a list
    rcopatterns = []
    for rco in rcolist:
        for p in rcolistgrouped:
            if rco in p:
                p=''.join(p)
                rcopatterns.append(p)

    #Add the patterns to csv
    rcv1['rccv1'] = rcopatterns

    #Remove duplicates and get the csv for computing
    rcv1fn = rcv1.drop_duplicates(subset=None)





    #Get v2 ~ nativeness
    rv2n =  rprepattern2[['s2vowel','nativeness']]
    rv2n['rv2n'] = rv2n.s2vowel + rv2n.nativeness
    rv2n = rv2n[['rv2n']]

    #Get v2 ~ coda
    rv2c =  rprepattern2[['s2vowel','coda']]
    rv2c['rv2c'] = rv2c.s2vowel + rv2c.coda
    rv2c = rv2c[['rv2c']]

    #Get nativeness ~ coda
    rnc2 =  rprepattern2[['nativeness','coda']]
    rnc2['rnc'] = rnc2.nativeness + rnc2.coda
    rnc2 = rnc2[['rnc']]


    #Combine all patterns
    rallpatterns2 = pandas.concat([rv2v1, rnv1, rcv1,rv2n,rv2c,rnc2], axis=1, join='inner')

    #Remove duplicates
    rallpatterns2fn = rallpatterns2.drop_duplicates(subset=None)


    #compute H(v2, coda, nativeness => v1)
    rallpatterns2b = rallpatterns2[['rv2v2v1','rnnv1','rccv1','rv2c','rv2n','rnc']]
    rallent21 = drv.entropy_joint(rallpatterns2.T)
    rallent22 = drv.entropy_joint(rallpatterns2b.T)
    rallent2 = rallent21 - rallent22
    os.remove('results_overall/bootall2.csv')
    os.remove('results_overall/prebootall2.csv')
    if rallent2 < ent.allent2:
        pallent2 = pallent2 + 1
        print ("H(v2, coda, nativeness => v1): bootstrap < actual, the values are: ",rallent2,",",ent.allent2,",","consider keeping the null hypothesis?")




# V2 => V1

    length6 = ent.v2v1fn.shape[0]
    with open('results_overall/prebootv2v1.csv','a+') as fic:
        print("s1vowel",",","s2vowel",sep='',file=fic)
        rowlists = []
        i = 0
        while len(rowlists) < length6:
            row = [random.choice(v1r), random.choice(v2r)]
            i = i + 1
            if row not in rowlists:
                rowlists.append(row)
                print(",".join(row),file=fic)

    preran = pandas.read_csv('results_overall/prebootv2v1.csv')  
    
    with open('results_overall/bootv2v1.csv','a+') as fic:
        preran.to_csv('results_overall/bootv2v1.csv',index=False)
        rowlists2 = []
        k = 0
        while len(rowlists2) < ent.v2v1.shape[0] - length6:
            row = preran.sample(1)
            k = k + 1
            rowlists2.append(row.iloc[0])
            print(",".join(row.iloc[0]),file=fic)


    dom1 = pandas.read_csv('results_overall/bootv2v1.csv')

    etv2v1 = dom1[['s2vowel','s1vowel']]

    #Combine v1 v2

    etv2v1['etv2v1'] = etv2v1.s2vowel + etv2v1.s1vowel

    etv2v1 = etv2v1[['etv2v1']]

    etvolist = etv2v1.etv2v1.tolist()

    #Remove duplicates
    etvolist2 = list(dict.fromkeys(etvolist))

    #Grouping the patterns and keep the values
    etvolistgrouped = group_by(0,etvolist2).values()

    #Add corresponding patterns to a list
    etvopatterns = []
    for rvo in etvolist:
        for p in etvolistgrouped:
            if rvo in p:
                p=''.join(p)
                etvopatterns.append(p)

    #Add the patterns to csv
    etv2v1['etv2v2v1']=etvopatterns

    #Remove duplicates and get the csv for computing
    etv2v1fn = etv2v1.drop_duplicates(subset=None)


    #compute v2 ~ v1 entropy
    etprev2v1entropy = drv.entropy_conditional(etv2v1fn.T)

    rv2v1entropy = etprev2v1entropy[0,1]
    os.remove('results_overall/bootv2v1.csv')
    os.remove('results_overall/prebootv2v1.csv')


    if rv2v1entropy < ent.v2v1entropy:
        pv2v1 = pv2v1 + 1
        print ("H(v2 => v1): bootstrap < actual, the values are: ",rv2v1entropy,",",ent.v2v1entropy,",","consider keeping the null hypothesis?")




#V2, coda => V1

    length7 = ent.v2codv1fn.shape[0]
    with open('results_overall/prebootv2codv1.csv','a+') as fic:
        print("s1vowel",",","s2vowel",",","coda",sep='',file=fic)
        rowlists = []
        i = 0
        while len(rowlists) < length7:
            row = [random.choice(v2r),random.choice(v1r),random.choice(codr)]
            i = i + 1
            if row not in rowlists:
                rowlists.append(row)
                print(",".join(row),file=fic)

    preran = pandas.read_csv('results_overall/prebootv2codv1.csv')  
    
    with open('results_overall/bootv2codv1.csv','a+') as fic:
        preran.to_csv('results_overall/bootv2codv1.csv',index=False)
        rowlists2 = []
        k = 0
        while len(rowlists2) < ent.v2codv1.shape[0] - length7:
            row = preran.sample(1)
            k = k + 1
            rowlists2.append(row.iloc[0])
            print(",".join(row.iloc[0]),file=fic)



    dom2 = pandas.read_csv('results_overall/bootv2codv1.csv')

    ftv2v1 = dom2[['s2vowel','s1vowel']]


    #Combine v1 v2

    ftv2v1['ftv2v1'] = ftv2v1.s2vowel + ftv2v1.s1vowel

    ftv2v1 = ftv2v1[['ftv2v1']]

    ftvolist = ftv2v1.ftv2v1.tolist()

    #Remove duplicates
    ftvolist2 = list(dict.fromkeys(ftvolist))

    #Grouping the patterns and keep the values
    ftvolistgrouped = group_by(0,ftvolist2).values()

    #Add corresponding patterns to a list
    ftvopatterns = []
    for rvo in ftvolist:
        for p in ftvolistgrouped:
            if rvo in p:
                p=''.join(p)
                ftvopatterns.append(p)

    #Add the patterns to csv
    ftv2v1['ftv2v2v1']= ftvopatterns



    #Find patterns for c ~  v1

    ftcv1 = dom2[['coda','s1vowel']]

    #Combine c v2
    ftcv1['ftcv1'] = ftcv1.coda + ftcv1.s1vowel

    #Extract the colunn cv2
    ftcv1 = ftcv1[['ftcv1']]

    #to list the patterns
    ftcolist = ftcv1.ftcv1.tolist()

    #Remove duplicates
    ftcolist2 = list(dict.fromkeys(ftcolist))

    #Grouping the patterns and keep the values
    ftcolistgrouped = group_by(0,ftcolist2).values()

    #Add corresponding patterns to a list
    ftcopatterns = []
    for rco in ftcolist:
        for p in ftcolistgrouped:
            if rco in p:
                p=''.join(p)
                ftcopatterns.append(p)

    #Add the patterns to csv
    ftcv1['ftccv1'] = ftcopatterns


    #Get v2 ~ coda
    ftv2c =  dom2[['s2vowel','coda']]
    ftv2c['ftv2c'] = ftv2c.s2vowel + ftv2c.coda
    ftv2c = ftv2c[['ftv2c']]

    #Combine all patterns
    ftall2c1 = pandas.concat([ftv2v1,ftcv1,ftv2c], axis=1, join='inner')

    #Remove duplicates
    ftall2c1fn = ftall2c1.drop_duplicates(subset=None)

    #compute H(v2, coda => v1)
    ftv2codv1b = ftall2c1[['ftv2v2v1','ftccv1','ftv2c']]
    ftv2codv1ent1 = drv.entropy_joint(ftall2c1.T)
    ftv2codv1ent2 = drv.entropy_joint(ftv2codv1b.T)
    rhv2codv1 = ftv2codv1ent1 - ftv2codv1ent2
    os.remove('results_overall/bootv2codv1.csv')
    os.remove('results_overall/prebootv2codv1.csv')
    if rhv2codv1 < ent.hv2codv1:
        pv2codv1 = pv2codv1 + 1
        print ("H(v2, coda => v1): bootstrap < actual, the values are: ",rhv2codv1,",",ent.hv2codv1,",","consider keeping the null hypothesis?")





#V2, nativeness => V1

    length8 = ent.v2nv1fn.shape[0]
    with open('results_overall/prebootv2nv1.csv','a+') as fic:
        print("s1vowel",",","s2vowel",",","nativeness",sep='',file=fic)
        rowlists = []
        i = 0
        while len(rowlists) < length8:
            row = [random.choice(v2r),random.choice(v1r),random.choice(natr)]
            i = i + 1
            if row not in rowlists:
                rowlists.append(row)
                print(",".join(row),file=fic)

    preran = pandas.read_csv('results_overall/prebootv2nv1.csv')  
    
    with open('results_overall/bootv2nv1.csv','a+') as fic:
        preran.to_csv('results_overall/bootv2nv1.csv',index=False)
        rowlists2 = []
        k = 0
        while len(rowlists2) < ent.v2nv1.shape[0] - length8:
            row = preran.sample(1)
            k = k + 1
            rowlists2.append(row.iloc[0])
            print(",".join(row.iloc[0]),file=fic)


    dom3= pandas.read_csv('results_overall/bootv2nv1.csv')

    gtv2v1 = dom3[['s2vowel','s1vowel']]


    #Combine v1 v2

    gtv2v1['gtv2v1'] = gtv2v1.s2vowel + gtv2v1.s1vowel

    gtv2v1 = gtv2v1[['gtv2v1']]

    gtvolist = gtv2v1.gtv2v1.tolist()

    #Remove duplicates
    gtvolist2 = list(dict.fromkeys(gtvolist))

    #Grouping the patterns and keep the values
    gtvolistgrouped = group_by(0,gtvolist2).values()

    #Add corresponding patterns to a list
    gtvopatterns = []
    for rvo in gtvolist:
        for p in gtvolistgrouped:
            if rvo in p:
                p=''.join(p)
                gtvopatterns.append(p)

    #Add the patterns to csv
    gtv2v1['gtv2v2v1']= gtvopatterns


    #Find patterns for n ~  v1

    gtnv1 = dom3[['nativeness','s1vowel']]

    #Combine n v1
    gtnv1['gtnv1'] = gtnv1.nativeness + gtnv1.s1vowel

    #Extract the colunn nv1
    gtnv1 = gtnv1[['gtnv1']]

    #to list the patterns
    gtnalist = gtnv1.gtnv1.tolist()

    #Remove duplicates
    gtnalist2 = list(dict.fromkeys(gtnalist))

    #Grouping the patterns and keep the values
    gtnalistgrouped = group_by(0,gtnalist2).values()

    #Add corresponding patterns to a list
    gtnapatterns = []
    for rna in gtnalist:
        for p in gtnalistgrouped:
            if rna in p:
                p=''.join(p)
                gtnapatterns.append(p)

    #Add the patterns to csv
    gtnv1['gtnnv1'] = gtnapatterns


    #Get v2 ~ nativeness
    gtv2n =  dom3[['s2vowel','nativeness']]
    gtv2n['gtv2n'] = gtv2n.s2vowel + gtv2n.nativeness
    gtv2n = gtv2n[['gtv2n']]


    #Combine all patterns
    gtall2n1 = pandas.concat([gtv2v1,gtnv1,gtv2n], axis=1, join='inner')

    #Remove duplicates
    gtall2n1fn = gtall2n1.drop_duplicates(subset=None)


    #compute H(v2, nativeness => v1)
    gtv2nv1b = gtall2n1[['gtv2v2v1','gtnnv1','gtv2n']]
    gtv2nv1ent1 = drv.entropy_joint(gtall2n1.T)
    gtv2nv1ent2 = drv.entropy_joint(gtv2nv1b.T)
    rhv2nv1 = gtv2nv1ent1 - gtv2nv1ent2
    os.remove('results_overall/bootv2nv1.csv')
    os.remove('results_overall/prebootv2nv1.csv')
    if rhv2nv1 < ent.hv2nv1:
        pv2nv1 = pv2nv1 + 1
        print ("H(v2, nativeness => v1): bootstrap < actual, the values are: ",rhv2nv1,",",ent.hv2nv1,",","consider keeping the null hypothesis?")

 

    #Output file
    path=os.path.join('results_overall/',outputfile1)
    with open(path,'a+') as f:
        print(rv1v2entropy,",",rhv1codv2,",",rhv1nv2,",",rallent,",",rv2v1entropy,",",rhv2codv1,",",rhv2nv1,",",rallent2,file=f)
    
    j = j + 1
    print (j)

#Mean and variance
boota = pandas.read_csv(path)

mean1 = boota['Hv1v2'].mean()
mean2 = boota['Hv1codv2'].mean()
mean3 = boota['Hv1nv2'].mean()
mean4 = boota['Hv1codnv2'].mean()
mean5 = boota['Hv2v1'].mean()
mean6 = boota['Hv2codv1'].mean()
mean7 = boota['Hv2nv1'].mean()
mean8 = boota['Hv2codnv1'].mean()

var1 = boota['Hv1v2'].var()
var2 = boota['Hv1codv2'].var()
var3 = boota['Hv1nv2'].var()
var4 = boota['Hv1codnv2'].var()
var5 = boota['Hv2v1'].var()
var6 = boota['Hv2codv1'].var()
var7 = boota['Hv2nv1'].var()
var8 = boota['Hv2codnv1'].var()


# For the histograms
nd1v1 = boota[['Hv1v2']]
nd2v1cod = boota[['Hv1codv2']]
nd2v1n = boota[['Hv1nv2']]
nd3v1 = boota[['Hv1codnv2']]
nd1v2 = boota[['Hv2v1']]
nd2v2cod = boota[['Hv2codv1']]
nd2v2n = boota[['Hv2nv1']]
nd3v2 = boota[['Hv2codnv1']]





 



path=os.path.join('results_overall/',outputfile2)
with open('results_overall/'+outputfile2, 'a+') as fi:
    print("Bootstrap statistic results",'\n','\n','\n',"Mean H(v1 => v2): ", mean1,'\n',"Variance: ",var1,'\n','\n',"Mean H(v1, nativeness => v2): ", mean3,'\n',"Variance: ",var3,'\n','\n',"Mean H(v1, coda => v2): ", mean2,'\n',"Variance: ",var2,'\n','\n',"Mean H(v1, coda, nativeness => v2): ", mean4,'\n',"Variance: ",var4,'\n','\n','\n',"Mean H(v2 => v1): ", mean5,'\n',"Variance: ",var5,'\n','\n',"Mean H(v2,nativeness => v1): ", mean7,'\n',"Variance: ",var7,'\n','\n',"Mean H(v2, coda => v1): ", mean6,'\n',"Variance: ",var6,'\n','\n',"Mean H(v2, nativeness, coda => v1): ", mean8,'\n',"Variance: ",var8,'\n','\n',file=fi)


pathp = os.path.join('results_overall/',pfile)
with open(pathp,'a+') as pf:
    print("P-values",'\n','\n','\n',"V1,coda,nativeness => V2: ",pallent/times,'\n',"V1 => V2: ",pv1v2/times,'\n',"V1,coda => V2: ",pv1codv2/times,'\n',"V1,nativeness => V2: ",pv1nv2/times,'\n',"V2,coda,nativness => V1: ",pallent2/times,'\n',"V2 => V1: ", pv2v1/times,'\n',"V2,coda => V1: ",pv2codv1/times,'\n',"V2,nativness => V1: ",pv2nv1/times,file=pf)
